package com.alniks.test.cdi.web;

import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptor;
import javax.interceptor.InvocationContext;

/**
 *
 * @author Alex Saluk
 */
@Logged
@Interceptor
public class LoggingInterceptor {
    
    private static int COUNTER;
    private int number;
    private int intercepted;

    public LoggingInterceptor() {
        
        System.out.println("++++++ Iterceptor constructor invoked " + ++COUNTER +" times ++++++++");
        number = COUNTER;
    }
    
    @AroundInvoke
    public Object logError(InvocationContext context) throws Exception{
        System.out.println("before invocation of " + context.getMethod().getName() + 
                " in " + context.getTarget().getClass().getSimpleName());
        System.out.println("current intercentor instance: " + number);
        System.out.println("method " + context.getMethod().getName() + " has been intercepted " + ++intercepted + " times");
        Object result = null;
        long time = System.currentTimeMillis();
        try {
            result = context.proceed();
        } catch (Throwable error) {
            System.out.println("Exception caught: " + error.getMessage());
            throw new RuntimeException(error);
        }
        System.out.println("method execution took " + (System.currentTimeMillis() - time) + " ms ");
        return result;
    }
    
}
